VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "ViewText []"
   ClientHeight    =   5685
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   8715
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   5685
   ScaleWidth      =   8715
   Begin VB.TextBox txtFile 
      Height          =   2415
      Left            =   2280
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   4
      Top             =   0
      Width           =   3255
   End
   Begin VB.ComboBox PatternCombo 
      Height          =   315
      Left            =   0
      TabIndex        =   3
      Text            =   "Combo1"
      Top             =   3600
      Width           =   2175
   End
   Begin VB.DriveListBox DriveList 
      Height          =   315
      Left            =   0
      TabIndex        =   2
      Top             =   0
      Width           =   2175
   End
   Begin VB.DirListBox DirList 
      Height          =   1155
      Left            =   0
      TabIndex        =   1
      Top             =   360
      Width           =   2175
   End
   Begin VB.FileListBox FileList 
      Height          =   1845
      Left            =   0
      TabIndex        =   0
      Top             =   1560
      Width           =   2175
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' The file currently displayed.
Private m_FileName As String

' API declarations used to move files
' to the wastebasket.
Private Type SHFILEOPSTRUCT
    hwnd As Long
    wFunc As Long
    pFrom As String
    pTo As String
    fFlags As Integer
    fAnyOperationsAborted As Long
    hNameMappings As Long
    lpszProgressTitle As Long ' Only used if FOF_SIMPLEPROGRESS
End Type
Private Declare Function SHFileOperation Lib "shell32.dll" Alias "SHFileOperationA" (lpFileOp As SHFILEOPSTRUCT) As Long
Private Const FO_DELETE = &H3
Private Const FOF_ALLOWUNDO = &H40
Private Const FOF_NOCONFIRMATION = &H10             '  Don't prompt the user.

Private Sub DirList_Change()
    FileList.Path = DirList.Path
End Sub

Private Sub DriveList_Change()
    'On Error GoTo DriveError
    DirList.Path = DriveList.Drive
    Exit Sub

DriveError:
    DriveList.Drive = DirList.Path
    Exit Sub
End Sub


Private Sub Form_Load()
    KeyPreview = True

    PatternCombo.AddItem "Text Files (*.txt)"
    PatternCombo.AddItem "All Files (*.*)"
    PatternCombo.ListIndex = 0

    DriveList.Drive = App.Path
    DirList.Path = App.Path
End Sub

' If the user presses Delete, move the current
' file into the wastebasket.
' If the user presses Backspace, kill the file.
Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
Dim op As SHFILEOPSTRUCT

    ' Make sure we have a file name.
    If Len(m_FileName) = 0 Then Exit Sub

    ' See what key this is.
    If (KeyCode = vbKeyBack) Then
        ' Backspace. Kill the file.
        Kill m_FileName

        m_FileName = ""
        Caption = "ViewText []"
        txtFile.Text = ""
        DirList_Change
    ElseIf (KeyCode = vbKeyDelete) And (Len(m_FileName) > 0) Then
        ' Delete. Move the file into the wastebasket.
        With op
            .wFunc = FO_DELETE
            .pFrom = m_FileName
            .fFlags = _
                FOF_ALLOWUNDO Or _
                FOF_NOCONFIRMATION
        End With

        On Error Resume Next
        SHFileOperation op

        If Err.Number <> 0 Then
            MsgBox "Error " & Format$(Err.Number) & _
                " deleting file " & m_FileName & _
                vbCrLf & Err.Description
        Else
            m_FileName = ""
            Caption = "ViewText []"
            txtFile.Text = ""
            DirList_Change
        End If
        On Error GoTo 0
    End If
End Sub


Private Sub FileList_Click()
Dim fnum As Integer
Dim txt As String

    On Error GoTo LoadFileError

    ' Compose the file name.
    m_FileName = FileList.Path
    If Right$(m_FileName, 1) <> "\" Then m_FileName = m_FileName & "\"
    m_FileName = m_FileName & FileList.FileName

    ' Display the file name.
    Caption = "FileView [" & m_FileName & "]"

    ' Load the file's text.
    fnum = FreeFile
    Open m_FileName For Input As fnum
    txt = Input$(LOF(fnum), #fnum)
    Close #fnum
    txtFile.Text = txt

    Exit Sub

LoadFileError:
    Beep
    Caption = "FileView [Invalid file]"
    m_FileName = ""
    txtFile.Text = "[Invalid File]"
    Exit Sub
End Sub


Private Sub Form_Resize()
Const GAP = 60

Dim wid As Integer
Dim hgt As Integer

    If WindowState = vbMinimized Then Exit Sub

    wid = DriveList.Width
    DriveList.Move GAP, GAP, wid
    PatternCombo.Move GAP, ScaleHeight - PatternCombo.Height, wid
    
    hgt = (PatternCombo.Top - DriveList.Top - DriveList.Height - 3 * GAP) / 2
    If hgt < 100 Then hgt = 100
    DirList.Move GAP, DriveList.Top + DriveList.Height + GAP, wid, hgt
    FileList.Move GAP, DirList.Top + DirList.Height + GAP, wid, hgt

    wid = ScaleWidth - txtFile.Left
    If wid < 120 Then wid = 120
    txtFile.Move txtFile.Left, 0, wid, ScaleHeight
End Sub
Private Sub PatternCombo_Click()
Dim pat As String
Dim p1 As Integer
Dim p2 As Integer

    pat = PatternCombo.List(PatternCombo.ListIndex)
    p1 = InStr(pat, "(")
    p2 = InStr(pat, ")")
    FileList.Pattern = Mid$(pat, p1 + 1, p2 - p1 - 1)
End Sub
